#include "svc.h"
#include "xdr.h"
#include<sys/types.h>
#include<stdlib.h>
#include<alloca.h>
#include<string.h>
#include"const.h"

/* Create an rpc service */
#define BUFFER_SIZE 4096

struct svc_serv *  svc_create(int sd, struct svc_program * prog, unsigned int bufsize, unsigned int xdrSize)
{
	struct svc_serv * serv;
	serv = (struct svc_serv *)malloc(sizeof(struct svc_serv)); 
	if(NULL == serv)
	{
		return NULL;	
	}
 	memset(serv, 0, sizeof(struct svc_serv));
	serv->sockFd = sd;
	rpc_register(sd, 0, 0, 0, 0, 0 ); /* dummy call */ 
	rpc_register(sd, NFS_PROGRAM, 2, IPPROTO_TCP, 2049, 1);
	rpc_register(sd, NFS_PROGRAM, 2, IPPROTO_UDP, 2049, 1);
	rpc_register(sd, MOUNTPROG,  2, IPPROTO_TCP, 2049, 1);
	rpc_register(sd, MOUNTPROG, 2, IPPROTO_UDP, 2049, 1);
	/* serv->serv_program = prog;
	serv->num_threads = 1;
	serv->serv_bufsize = (bufsize ? bufsize : BUFFER_SIZE);
	serv->serv_xdrBuffSize = xdrSize;
        serv->serv_name = prog->pg_name; */
	return serv;	
}
